<?php

/**
 * cbr_comite_resol actions.
 *
 * @package    cobro_coactivo
 * @subpackage cbr_comite_resol
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cbr_comite_resolActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_COMITE_RESOL',
        'CBR_COMITE_CARTERA',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'CBR_TIPO_DOCUMENTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_COMITE_CARTERA,LEFT' =>
        array(
            'id_comite_cartera' => 'CBR_COMITE_RESOL'
        ),
        'CBR_REMISION_TITULO,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_COMITE_CARTERA'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_COMITE_RESOL'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_COMITE_RESOL' =>
        array(
            'id_comite_resol' => 'id_comite_resol',
            'id_comite_cartera' => 'id_comite_cartera',
            'no_resol' => 'no_resol',
            'fecha_resol' => 'fecha_resol',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'id_tipo_documento' => 'id_tipo_documento',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log'
        ),
        'CBR_COMITE_CARTERA' =>
        array(
            'id_comite_cartera' => 'id_comite_cartera_car',
            'id_remision_titulo' => 'id_remision_titulo',
            'no_comite' => 'no_comite',
            'fecha_comite' => 'fecha_comite',
            'observaciones' => 'observaciones_car',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log_car',
            'usuario_log' => 'usuario_log_car'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado_remision_titulo',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_comite_resol'
    ); //campos para el ordenamiento de la consulta


    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_COMITE_RESOL' =>
        array(
            'id_comite_resol,a' => array('!=' => array(-1)),
            'id_comite_resol,b' => array('=' => array('id_comite_resol')),
            'id_comite_cartera' => array('=' => array('id_comite_cartera')),
            'fecha_resol' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'no_resol' => array('=' => array('no_resol')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo')),
            'numero_remision' => array('=' => array('numero_remision')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia')),
            'anho_remision' => array('=' => array('id_anhos')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_comite_resol'; //identificador unico de la tabla
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_comite_resol'; //identificador de la tabla
    protected $id_names = array('id_comite_resol'); //llave primaria
    protected $field_names = array('id_comite_cartera', 'no_resol', 'fecha_resol', 'observaciones',
        'adjunto', 'id_tipo_documento', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_COMITE_RESOL'; //tabla en la cual se aplican los cambios 

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['id_username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            if (isset($request['no_resol'])){
                $id_comite_resol = $list_data_post[0]['id_comite_resol']; 
                //Metodo Sobreescribir Documento
                //setlocale(LC_ALL, 'es_ES');
                //$fechaDocumento = date('d-F-Y',strtotime($list_data_post[0]['fecha_aprueba']));
                $meses = array("Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre");
                    $dia = date('d',strtotime($list_data_post[0]['fecha_aprueba']));
                    $mes = $meses[date('m',strtotime($list_data_post[0]['fecha_aprueba'])) - 1];
                    $año = date('Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $fechaDocumento = "$dia - $mes - $año";
                    $datosModificar = Array(
                        'numeroDocumento' => $list_data_post[0]['no_resol'],
                        'fechaDocumento' => $fechaDocumento
                    );
                    //Obtenemos la ruta donde e almacena el adjunto
                    
                    $ruta_documento = getcwd() . "/uploads/resol_comite/";
                    $documento = $ruta_documento.$list_data_post[0]['adjunto'];
                    $logger->info("Actualizar Documento - " . $documento);
                    $new_documento = CN_TABLE::sobreescribirDocumentoWord($datosModificar, $documento);
                    $logger->info("Se Actaulizo el documento - $documento y se creo $new_documento");
                    // Actualizamos el archivo en el campo Adjunto
                    $sql = <<<EOD
update cbr_comite_resol SET ADJUNTO = '$new_documento'  
 where id_comite_resol = $id_comite_resol
EOD;
                    $this->conn->execute($sql);
                
            }
            
        }

        //accion update
        if ($Action == "UPDATE") {
            if (isset($request['no_resol'])){
                $id_comite_resol = $list_data_post[0]['id_comite_resol']; 
                //Metodo Sobreescribir Documento
                //setlocale(LC_ALL, 'es_ES');
                //$fechaDocumento = date('d-F-Y',strtotime($list_data_post[0]['fecha_aprueba']));
                $meses = array("Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre");
                    $dia = date('d',strtotime($list_data_post[0]['fecha_aprueba']));
                    $mes = $meses[date('m',strtotime($list_data_post[0]['fecha_aprueba'])) - 1];
                    $año = date('Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $fechaDocumento = "$dia - $mes - $año";
                    $datosModificar = Array(
                        'numeroDocumento' => $list_data_post[0]['no_resol'],
                        'fechaDocumento' => $fechaDocumento
                    );
                    //Obtenemos la ruta donde e almacena el adjunto
                    
                    $ruta_documento = getcwd() . "/uploads/resol_comite/";
                    $documento = $ruta_documento.$list_data_post[0]['adjunto'];
                    $logger->info("Actualizar Documento - " . $documento);
                    $new_documento = CN_TABLE::sobreescribirDocumentoWord($datosModificar, $documento);
                    $logger->info("Se Actaulizo el documento - $documento y se creo $new_documento");
                    // Actualizamos el archivo en el campo Adjunto
                    $sql = <<<EOD
update cbr_comite_resol SET ADJUNTO = '$new_documento'  
 where id_comite_resol = $id_comite_resol
EOD;
                    $this->conn->execute($sql);
                
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
